<?php
/*
##############################################################################
#    Plugin for xt:Commerce VEYTON 4.0 Enterprise
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# @version $Id: class.vt_findologic_editor.php 3752 2014-04-09 13:39:28Z s.thamm $
# @copyright:   found in /lic/copyright.txt
#
##############################################################################
*/

defined('_VALID_CALL') or die('Direct Access is not allowed.');


	class vt_findologic_editor {
		protected $_table = TABLE_VT_FINDOLOGIC;
		protected $_table_lang = null;
		protected $_table_seo = null;
		protected $_master_key = 'findologic_id';

		function __construct() {
		}

		function setPosition($position) {
			$this->position = $position;
		}

		function _getParams() {
			global $language, $xtPlugin;

			$params = array();

			$header['findologic_file'] = array('type' => 'input');
			$header['findologic_lang_code'] = array('type' => 'dropdown','url'  => 'DropdownData.php?get=language_codes');
                        $header['findologic_shop_id'] = array('type' => 'dropdown','url'  => 'DropdownData.php?get=stores');
			$header['findologic_lastexport'] = array('type' => 'hidden');
			$header['findologic_shopkey'] = array('type' => 'input');

			$grouping['findologic_shopkey'] = array('position' => 'default');

			$rowActions[] = array('iconCls' => 'run_export', 'qtipIndex' => 'qtip1', 'tooltip' => 'Run');

			if ($this->url_data['edit_id'])
				$js = "var edit_id = ".$this->url_data['edit_id'].";";
			else
                $js = "var edit_id = record.id;";

			$js.= "Ext.Msg.confirm('Findologic Export','Export CSV?',function(btn){doFindologicExport(edit_id, btn);})";

			$rowActionsFunctions['run_export'] = $js;

			$js = "function doFindologicExport(edit_id, btn){
				if(btn == 'yes') {
					addTab('row_actions.php?type=findologic_export&id='+edit_id,'".TEXT_DO_FINDOLOGIC_EXPORT."');
				}
			};";

			if(!$this->url_data['edit_id'] && $this->url_data['new'] != true)
				$params['include'] = array ('findologic_id', 'findologic_file', 'findologic_lang_code', 'findologic_lastexport');

			$params['grouping'] = $grouping;
			$params['rowActionsJavascript'] = $js;
			$params['rowActions'] = $rowActions;

			if (!$this->url_data['edit_id'] && $this->url_data['new'] != true)
				$params['rowActionsFunctions'] = $rowActionsFunctions;

			$params['header'] = $header;
			$params['master_key'] = $this->_master_key;
			$params['default_sort'] = $this->_master_key;

			return $params;
		}

		function _get($ID = 0) {
			global $xtPlugin, $db, $language;

			if($this->position != 'admin') return false;

			if ($ID === 'new') {
				$obj = $this->_set(array(), 'new');
				$ID = $obj->new_id;
			}

			$table_data = new adminDB_DataRead($this->_table, $this->_table_lang, $this->_table_seo, $this->_master_key);

			if ($this->url_data['get_data'])
				$data = $table_data->getData();
			elseif($ID)
				$data = $table_data->getData($ID);
			else
				$data = $table_data->getHeader();

			$obj = new stdClass;
			$obj->totalCount = count($data);
			$obj->data = $data;

			return $obj;
		}

		function _set($data, $set_type = 'edit'){
			global $xtPlugin;

			$obj = new stdClass;

			$o = new adminDB_DataSave($this->_table, $data, false, __CLASS__);
			$obj = $o->saveDataSet();

			if ($obj->success)
				$obj->success = true;
			else
				$obj->failed = true;

			return $obj;
		}

		function _unset($id = 0) {
			global $db;

			if($id == 0) return false;

			if($this->position != 'admin') return false;

			$db->Execute("DELETE FROM ". $this->_table ." WHERE ".$this->_master_key." = ".$id);
		}
	}

?>