<?php
/*
##############################################################################
#    Plugin for xt:Commerce VEYTON 4.0 Enterprise
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# @version $Id: class.vt_findologic_export.php 6519 2015-11-09 10:01:32Z r.siemoneit $
# @copyright:   found in /lic/copyright.txt
#
##############################################################################
*/

defined('_VALID_CALL') or die('Direct Access is not allowed.');


require_once _SRV_WEBROOT._SRV_WEB_FRAMEWORK.'admin/classes/class.adminDB_DataRead.php';

class vt_findologic_export {
	protected $_table = TABLE_VT_FINDOLOGIC;
	protected $_table_lang = null;
	protected $_table_seo = null;
	protected $_master_key = 'findologic_id';
	protected $delimiter = "\t";
	protected $enclosure = "\"";

	function __construct() {
	}

	public function startExport($data) {
		global $db;

		@set_time_limit(0);

		$this->setValues($_GET['id']);

		if($data['user'] != $this->findologic_exportuser || $data['pass'] != $this->findologic_exportpass)
			die("-- LOGIN FAILED - USER OR PASS WRONG --");

		if(isset($data['cronjob']))
			$this->cronjob = true;
		else
			$this->cronjob = false;

		if($data['start'])
			$this->start = $data['start'];
		else {
			$this->start = 0;

			$db->Execute("UPDATE ".$this->_table." SET findologic_lastexport=NOW() WHERE findologic_id=".$this->findologic_id);
		}

		if(isset($data['externlimit']))
			$this->findologic_limit = $data['externlimit'];

		$this->process($data);
	}

	protected function setValues($ID){
		global $db, $store_handler;

		$table_data = new adminDB_DataRead($this->_table, $this->_table_lang, $this->_table_seo, $this->_master_key);
		$data = $table_data->getData($ID);

		if(is_array($data) && count($data > 0))
			foreach ($data[0] as $key => $val)
				$this->$key = $val;

			if(!$this->findologic_limit)
				$this->findologic_limit = 100;

			if(!$this->findologic_lang_code)
				$this->findologic_lang_code = "de";

			if(!$this->findologic_file)
				$this->findologic_file = "findologic_".$this->findologic_lang_code.".csv";

			if(VT_FINDOLOGIC_EXPORTALLSHOPS_STATUS == "true")
				$this->findologic_file = "shop_all_".$this->findologic_file;
			else
				$this->findologic_file = "shop_".$store_handler->shop_id."_".$this->findologic_file;
		}

		protected function process($data) {
			global $db, $language, $store_handler;

			$header_added = false;

			$fp = $this->openFile();

			$this->old_lang = $language->code;
			$language->code = $this->findologic_lang_code;

			if(VT_FINDOLOGIC_EXPORTALLSHOPS_STATUS == "true") {
				$this->old_shop = $store_handler->shop_id;
			}

			$stores = $db->Execute('SELECT * FROM ' . TABLE_MANDANT_CONFIG);

			foreach($stores as $store)
			{
				$store_handler->shop_id = $store['shop_id'];

				$sql_products = new getProductSQL_query();

				$query = $sql_products->getSQL_query();

				$rs_count = $db->Execute($query);
				$this->total_products = $rs_count->RecordCount();

				$query .= ' LIMIT '.$this->start.', '.$this->findologic_limit;
				$record = $db->Execute($query);

				if ($record->RecordCount() > 0) {
					while(!$record->EOF) {
						$ordernumbers = array();

						$line = array();

						$product = new product($record->fields['products_id']);

						$ordernumbers[] = $product->data['products_model'];

						if($product->data['products_master_flag'] == 1)
							$ordernumbers = array_merge($ordernumbers, $this->getSlaveProductModels($product->data['products_model']));

						$ordernumbers = implode("|", $ordernumbers);

						$line['id'] = $product->data['products_id'];
						$line['ordernumber'] = $ordernumbers;
						$line['name'] = $product->data['products_name'];
						$line['summary'] = $this->cleanString($product->data['products_short_description']);
						$line['description'] = $this->cleanString($product->data['products_description']);
						$line['price'] = round($product->data['products_price']['plain'], 2);
						$line['taxrate'] = $product->data['products_tax_rate'];
						$line['url'] = $this->buildProductUrl($product->data['products_link']);
						$line['image'] = $this->buildImageUrl($product->data['products_image']);
						$line['attributes'] = $this->buildAttributes($product);
						$line['keywords'] = $product->data['products_keywords'];

						if(VT_FINDOLOGIC_EXPORTALLSHOPS_STATUS == "true")
							$line['groups'] = $this->getShopsForProduct($product->data['products_id']);
						else
							$line['groups'] = $store_handler->shop_id;

						$line['sales_frequency'] = $product->data['products_ordered'];
						$line['date_added'] = strtotime($product->data['date_added']);
						$line['sort'] = $product->data['products_sort'];

						if($this->start == 0 && $header_added == false) {

							$header = $this->getHeader($line);

							fputcsv($fp, $header, $this->delimiter, $this->enclosure);

							$header_added = true;
						}

						fputcsv($fp, $line, $this->delimiter, $this->enclosure);

						$record->MoveNext();
					} $record->Close();
				}
			}

			fclose($fp);

			$language->code = $this->old_lang;
			unset($this->old_lang);

			if(VT_FINDOLOGIC_EXPORTALLSHOPS_STATUS == "true")
				$store_handler->shop_id = $this->old_shop;

			$this->redirecting($data);
		}

		function buildProductUrl($url) {
			// return $url; // Absoluter Pfad
			return str_replace(_SYSTEM_BASE_URL._SRV_WEB, "", $url); // Relativer Pfad
		}

		function buildImageUrl($img) {
			$img = explode(':', $img);
			$img = $img[1];

			//$url = _SYSTEM_BASE_URL._SRV_WEB._SRV_WEB_IMAGES._DIR_THUMB.$img; // Absoluter Pfad
			$url = _SRV_WEB_IMAGES._DIR_THUMB.$img; // Relativer Pfad
			$url = preg_replace('/xtadmin\//i', '', $url);

			return $url;
		}

		function openFile() {
			$file = _SRV_WEBROOT.'export/'.$this->findologic_file;

			if($this->start == 0)
				if(file_exists($file))
					unlink($file);

				$fp = fopen($file, "a");

				return $fp;
			}

			function getHeader($columns) {
				$header = array();

				foreach ($columns as $column => $unused)
					$header[] = $column;

				return $header;
			}

			protected function cleanString($val) {
				$val = strip_tags($val);
				$val = addslashes($val);
				$val = str_replace("\n", " ", $val);
				$val = str_replace("\r", " ", $val);
				$val = str_replace("\t", " ", $val);

				return $val;
			}

			protected function getSlaveProductModels($master_model) {
				global $db;

				$arr = array();

				$sql = 'SELECT products_model FROM '.TABLE_PRODUCTS.' WHERE products_master_model="'.$master_model.'"';
				$rs = $db->Execute($sql);

				if($rs->RecordCount() > 0) {
					while(!$rs->EOF) {
						$arr[] = $rs->fields['products_model'];

						$rs->MoveNext();
					} $rs->Close();
				}

				return $arr;
			}

			protected function buildAttributes($product) {
				global $language, $db, $xtPlugin;

				$attr_path='';
				$attr_contents=array();

			// manufacturers
				if(isset($product->data['manufacturers_id']) && $product->data['manufacturers_id'] != 0) {
					$manufacturer = new manufacturer($product->data['manufacturers_id']);
					$attr_contents[] = 'vendor='.urlencode($manufacturer->data['manufacturers_name']);
				}

			// categories
				if($product->data['products_master_flag'] == 1)
					$attr_contents[] = $this->buildMasterSlaveCatPath($product->data['products_id'], $product->data['products_model']);
				else
					$attr_contents[] = $this->buildNormalCatPath($product->data['products_id']);

			// master-slave attributes
				if($product->data['products_master_flag'] == 1)
					$attr_contents[] = $this->buildMasterSlaveAttributes($product->data['products_model']);

			// technical data
				if(defined(FINDOLOGIC_TD_SPECIAL) && $xtPlugin->active_modules['vt_technical_data'] === 'true')
					$attr_contents[] = $this->buildTechnicalDataAttributes($product->data['products_id']);

			// build return string
				if(is_array($attr_contents) && count($attr_contents) > 0)
					$attr_path = implode('&', $attr_contents);

				return $attr_path;
			}

			protected function buildMasterSlaveAttributes($products_model) {
				global $db;

				$ids = array();
				$tmp_attr = array();

				$ids = $this->getMasterSlaveProductIds($products_model);

				if(count($ids) == 0) return;

				$rs = $db->Execute("SELECT * FROM ".TABLE_PRODUCTS_TO_ATTRIBUTES." WHERE products_id IN(".implode(',', $ids).")");

				if($rs->RecordCount() > 0) {
					while(!$rs->EOF) {
						$tmp_attr[$rs->fields['attributes_parent_id']][] = $rs->fields['attributes_id'];

						$rs->MoveNext();
					} $rs->Close();

					foreach($tmp_attr as $attr_key => $attr_values) {
						$attr_key_name = $db->GetOne('SELECT attributes_name FROM '.TABLE_PRODUCTS_ATTRIBUTES_DESCRIPTION.' WHERE attributes_id='.$attr_key.' AND language_code="'.$this->findologic_lang_code.'"');

						foreach($attr_values as $attr_value) {
							$attr_value_name = $db->GetOne('SELECT attributes_name FROM '.TABLE_PRODUCTS_ATTRIBUTES_DESCRIPTION.' WHERE attributes_id='.$attr_value.' AND language_code="'.$this->findologic_lang_code.'"');

							$attr_arr[] = urlencode($attr_key_name)."=".urlencode($attr_value_name);
						}
					}

					$attributes = implode('&', $attr_arr);

					return $attributes;
				}
			}

			protected function buildTechnicalDataAttributes($products_id) {
				global $db, $language;

				$attr_arr = array();

				require_once _SRV_WEBROOT._SRV_WEB_PLUGINS.'vt_technical_data/classes/tables_def.php';

				$sql = '
				SELECT tdsgd.name AS `group`, tdvd.value AS `value`
				FROM '.TABLE_TD2_GROUPS.' AS tdg
				INNER JOIN '.TABLE_TD2_SUBGROUPS.' AS tdsg
				ON tdg.group_id=tdsg.group_id
				INNER JOIN '.TABLE_TD2_SUBGROUPS_DESC.' as tdsgd
				ON tdsg.subgroup_id=tdsgd.subgroup_id AND tdsgd.language_code="'.$language->code.'"
				INNER JOIN '.TABLE_TD2_VALUES.' AS tdv
				ON tdsg.subgroup_id=tdv.subgroup_id
				INNER JOIN '.TABLE_TD2_VALUES_DESC.' AS tdvd
				ON tdv.value_id=tdvd.value_id AND tdvd.language_code="'.$language->code.'"
				INNER JOIN '.TABLE_TD2_PRODUCT_VALUES.' AS tdpv
				ON tdv.value_id=tdpv.vvalue_id
				WHERE tdg.status=1 AND tdsg.status=1 AND tdv.status=1 AND tdpv.vstatus=1 AND tdpv.products_id='.$products_id.'
				ORDER BY tdpv.vsort_order';

				$results = $db->getAll($sql);

				if(is_array($results) && count($results) > 0)
					foreach($results as $result)
						$attr_arr[] = urlencode($result['group']).'='.urlencode($result['value']);

					return implode('&', $attr_arr);
				}

				function buildNormalCatPath($products_id) {
					global $db, $language;

					$normalCatPath = "";

					$rs = $db->Execute("SELECT DISTINCT categories_id FROM ".TABLE_PRODUCTS_TO_CATEGORIES." WHERE products_id='".$products_id."' ORDER BY master_link");

					$normalCatPath = $this->buildCatPath($rs);

					return $normalCatPath;		
				}

				protected function buildMasterSlaveCatPath($products_id, $products_model) {
					global $db, $language;

					$masterSlaveCatPath = "";
					$ids = array($products_id);

					$ids = array_merge($ids, $this->getMasterSlaveProductIds($products_model));
					$ids = array_unique($ids);

					$rs_slaves_cats = $db->Execute("SELECT DISTINCT categories_id FROM ".TABLE_PRODUCTS_TO_CATEGORIES." WHERE products_id IN (".implode(',', $ids).") ORDER BY master_link");

					$masterSlaveCatPath = $this->buildCatPath($rs_slaves_cats);

					return $masterSlaveCatPath;		
				}

				protected function getMasterSlaveProductIds($products_model) {
					global $db;

					$ids = array();

					$rs_slaves = $db->Execute("SELECT products_id FROM ".TABLE_PRODUCTS." WHERE products_master_model='".$products_model."' ORDER BY products_price ASC");

					if($rs_slaves->RecordCount() > 0) {
						while(!$rs_slaves->EOF) {
							$ids[] = $rs_slaves->fields['products_id'];

							$rs_slaves->MoveNext();
						} $rs_slaves->Close();
					}

					return $ids;
				}

				protected function buildCatPath($rs) {
					$path = "";

					if($rs->RecordCount() > 0) {
						while(!$rs->EOF) {
							$tmp_path = "";
							$tmp = array();

							$cat = new category($rs->fields['categories_id']);
							$tmp_path = $cat->getNavigationPath($rs->fields['categories_id']);
							$tmp_path = array_reverse($tmp_path);

							foreach($tmp_path as $val)
								$tmp[] = urlencode($val['categories_name']);

							$path[] = 'cat='.implode('_', $tmp);

							$rs->MoveNext();
						} $rs->Close();

						if(is_array($path) && count($path) > 0) {
							$catPath = implode('&', $path);
						}
					}

					return $catPath;
				}

				protected function getShopsForProduct($products_id) {
					global $db;

					if(_SYSTEM_GROUP_PERMISSIONS == "blacklist") {
						$shop_permission = array();

						$rs_stores = $db->Execute('SELECT shop_id FROM '.TABLE_MANDANT_CONFIG);

						foreach($rs_stores as $stores)
							$all_shops[] = $stores['shop_id'];

						$rs_permission = $db->Execute('SELECT pgroup FROM '.TABLE_PRODUCTS_PERMISSION.' WHERE pid='.$products_id.' AND pgroup LIKE "shop_%"');

						foreach($rs_permission as $val_permission)
							$shop_permission[] = str_replace("shop_", "", $val_permission['pgroup']);

						$shop = array_diff($all_shops, $shop_permission);
					} else {
						$rs = $db->Execute('SELECT pgroup FROM '.TABLE_PRODUCTS_PERMISSION.' WHERE pid='.$products_id.' AND pgroup LIKE "shop_%"');

						foreach($rs as $val)
							$shop[] = str_replace("shop_", "", $val['pgroup']);
					}

					$shops = implode(",", $shop);

					return $shops;
				}

				function redirecting($data) {
					global $xtLink, $info;

					if(($this->start + $this->findologic_limit < $this->total_products)) {
						$params = 'type=findologic_export&id='.$this->findologic_id."&start=".($this->start + $this->findologic_limit);

						if (isset($data['seckey'])) {
							$params .= '&' . http_build_query(array('seckey' => $data['seckey']));
						}

						if(isset($data['externlimit']))
							$params .= "&externlimit=".$data['externlimit'];

						if(isset($this->findologic_exportuser) && isset($this->findologic_exportpass))
							$params .= "&user=".$this->findologic_exportuser."&pass=".$this->findologic_exportpass;

						if($this->cronjob == true) {
							$params .= "&cronjob=1";
							$url = $xtLink->_link(array('default_page'=>'cronjob.php', 'params'=>$params));
							header('Location: ' . $url);
							exit (0);
						} else
						echo $this->displayHTML($xtLink->_link(array('default_page'=>'cronjob.php', 'params'=>$params)), $this->start, $this->findologic_limit, $this->total_products);
					} else {
						echo $this->htmlHeader();
						$info->_addInfo("Export-File '<b>" . $this->findologic_file . "</b>' created.", 'success');
						echo $info->info_content;
						echo $this->htmlFooter();
					}
				}

				function displayHTML($next_target, $start, $limit, $total) {
					$process = $start / $total * 100;

					if($process > 100) $process = 100;

					$upper = (($start + $limit) > $total) ? $total : ($start + $limit);

					$html='<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
					<html>
					<head>
						<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
						<meta http-equiv="refresh" content="0; URL='.$next_target.'" />
						<title>findologic-export</title>
						<style type="text/css"><!--
							.process_rating_light .process_rating_dark {
								background:#FF0000;
								height:15px;
								position:relative;
							}

							.process_rating_light {
								height:15px;
								margin-right:5px;
								position:relative;
								width:150px;
								border:1px solid;
							}
						--></style>
					</head>
					<body>
						<div class="process_rating_light"><div class="process_rating_dark" style="width:'.$process.'%">'.round($process,0).'%</div></div>
						Processing '.$lower.' to '.$upper.' of total '.$total.'
					</body>
					</html>';

					return $html;
				}

				function htmlHeader() {
					$html='<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
					<html>
					<head>
						<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
						<title>findologic-export</title>
						<style type="text/css"><!--
							ul.info_success {border:solid 2px #4DAA30; background-color:#BDFFA9; padding:8px}
							ul.info_success li {}
							ul.info_success li.infoSuccess {list-style:none; padding:5px 0px 2px 20px; background-image:url(images/icons/accept.png); background-repeat:no-repeat; background-position:0px 4px; background-color:#BDFFA9}
						--></style>
					</head>
					<body>';
						return $html;
					}

					function htmlFooter() {
						$html = '</body></html>';

						return $html;
					}
				}

				?>
