<?php

/*
  ##############################################################################
  #    Plugin for xt:Commerce VEYTON 4.0 Enterprise
  # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  # @version $Id: class.vt_findologic_search.php 5888 2015-05-12 09:30:47Z r.siemoneit $
  # @copyright:   found in /lic/copyright.txt
  #
  ##############################################################################
 */

defined('_VALID_CALL') or die('Direct Access is not allowed.');

class vt_findologic_search {

    public function __construct() {
    }

    public function BuildSearchURL(&$url, $keyword, $view, $order) {
        global $db, $language, $store_handler;

        if ($view > 1) {
            $first = ($view - 1) * VT_FINDOLOGIC_LIMITPRODUCTS_COUNT;
        } else {
            $first = 0;
        }

        $rs = $db->Execute("SELECT findologic_serviceurl, findologic_shopkey FROM " . TABLE_VT_FINDOLOGIC . " WHERE findologic_lang_code='" . $language->code . "' AND findologic_shop_id='" . $store_handler->shop_id . "'");

        $url = $rs->fields['findologic_serviceurl'] .
                '?shopkey=' . $rs->fields['findologic_shopkey'] .
                '&shopurl=' . $store_handler->domain .
                '&userip=' . $this->getUserIP() .
                '&referer=' . urlencode($_SERVER['HTTP_REFERER']) .
                '&revision=' . $this->getPluginVersion() .
                '&query=' . urlencode($keyword) .
                '&group[]=' . $store_handler->shop_id .
                "&count=" . VT_FINDOLOGIC_LIMITPRODUCTS_COUNT .
                "&first=" . $first;

        if ($order != "none") {
            $url .= '&order=' . urlencode($order);
        }

        if ($_GET['identifier']) {
            $url .= '&identifier=' . $_GET['identifier'];
        }
    }

    public function setFilter($get, &$url, &$data, &$params) {
        global $price;

        if ($get['attrib']) {
            foreach ($get['attrib'] as $key => $arrayValues) {
                if ($key != "price") {
                    foreach ($arrayValues as $val) {
                        $value = "&attrib[" . urlencode($key) . "][]=" . urlencode($val);
                        $data->selected_filter[] = array("value" => $value, "name" => $val);
                        $url .= $value;
                        $params .= $value;
                    }
                } else {
                    $value = "&attrib[" . $key . "][min]=" . $arrayValues['min'] . "&attrib[" . $key . "][max]=" . $arrayValues['max'];
                    $name = (string) $price->_StyleFormat($price->_roundPrice($price->_calcCurrency($arrayValues['min']))) . " -" . $price->_StyleFormat($price->_roundPrice($price->_calcCurrency($arrayValues['max'])));
                    $data->selected_filter[] = array("value" => $value, "name" => $name);
                    $url .= $value;
                    $params .= $value;
                }
            }
        }

        $params_array = explode("&", $params);
        unset($params_array[0]);

        if ($data->selected_filter) {
            foreach ($data->selected_filter as $key => $val) {
                // Variante 1 - Verursacht Probleme beim Preisfilter
                /*
                  $pos = array_search(substr($val['value'], 1), $params_array);

                  $params_array_copy = $params_array;

                  if($pos !== false)
                  unset($params_array_copy[$pos]);

                  if(count($params_array_copy) > 0)
                  $params_string = "&" . implode("&", $params_array_copy);

                  $data->selected_filter[$key]['params'] = $params_string; //str_replace($val['value'], "", $params);
                 */

                //  Variante 2 - Scheint an sich erstmal zu funktionieren
                $data->selected_filter[$key]['params'] = str_replace($val['value'], "", $params);
            }
        }
    }

    protected function getUserIP() {
        $userIP = "";

        if (!isset($_SERVER['HTTP_X_FORWARDED_FOR'])) {
            $userIP = $_SERVER['REMOTE_ADDR'];
        } else {
            $userIP = $_SERVER['HTTP_X_FORWARDED_FOR'];
        }

        return $userIP;
    }

    protected function getPluginVersion() {
        global $db;

        return $db->GetOne("SELECT version FROM " . TABLE_PLUGIN_PRODUCTS . " WHERE code='vt_findologic'");
    }

    public function callFindologic(&$url, &$xml) {
        global $xtLink;

        $response = '';
        $info = array();

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_TIMEOUT, 8);
        $response = curl_exec($ch);
        $info = curl_getinfo($ch);
        curl_close($ch);

        if ($info['http_code'] != 200) {
            $xtLink->_redirect($xtLink->_link(array('page' => 'search', 'params' => 'keywords=' . $_GET['keywords'] . "&std_search=1")));
        }

        $xml = new SimpleXMLElement($response);
    }

    /**
     * check if identifier used (click an entry in auto complete) and was only one article found, then redirect to the article
     */
    public function checkForIdentifier($xml, $params) {
        global $xtLink;

        $identifier = ($params['identifier']) ? $params['identifier'] : $_GET['identifier'];

        if (is_numeric($identifier) && $xml->results->count == 1) {
            $tprod = new product($identifier);
            $xtLink->_redirect($tprod->data['products_link']);
        }
    }

    public function buildQueryData($xml, &$data) {
        $data->query['count'] = (int) $xml->results->count;

        if ($xml->results->count == 0) {
            $data->query['string'] = sprintf(TEXT_FINDOLOGIC_RESULT_NOTHING, $xml->query->queryString);
        } elseif ($xml->results->count == 1) {
            $data->query['string'] = sprintf(TEXT_FINDOLOGIC_RESULT_SINGLE, $xml->query->queryString, $xml->results->count);
        } else {
            $data->query['string'] = sprintf(TEXT_FINDOLOGIC_RESULT_MULTIPLE, $xml->query->queryString, $xml->results->count);
        }
    }

    public function buildFilters($xml, &$data) {
        global $price, $db, $language;

        foreach ($xml->filters->filter as $query_filter) {
            $index = 0;

            foreach ($query_filter->items->item as $item) {
                $data->filter[(string) $query_filter->name][$index]['name'] = (string) $item->name;
                $data->filter[(string) $query_filter->name][$index]['frequency'] = (string) $item->frequency;
                $data->filter[(string) $query_filter->name][$index]['type'] = (string) $query_filter->select;
                $data->filter[(string) $query_filter->name][$index]['weight'] = (string) $item->weight;

                if ($query_filter->name == "price") {
                    $data->filter[(string) $query_filter->name][$index]['min'] = (string) $price->_roundPrice($price->_calcCurrency($item->parameters->min));
                    $data->filter[(string) $query_filter->name][$index]['max'] = (string) $price->_roundPrice($price->_calcCurrency($item->parameters->max));
                    $data->filter[(string) $query_filter->name][$index]['name'] = (string) $price->_StyleFormat($price->_roundPrice($price->_calcCurrency($item->parameters->min))) . " -" . $price->_StyleFormat($price->_roundPrice($price->_calcCurrency($item->parameters->max)));
                }

                $index++;
            }
        }
    }

    public function buildProductData($xml, &$data) {

        $data->products = array();

        foreach ($xml->products->product as $product) {
            $p = new product($product['id']);

            if ($p->data['products_status'] == 1) {
                $data->products[] = $p->data;
            }
        }
    }

    public function buildOrderDropdown(&$data, $order) {
        /* Passiert jetzt Templateseitig, wird hier nicht mehr gebraucht
          // Zuerst hinzugefügt auf Wunsch von Findologic, nun wieder entfernt von Wunsch auf Findologic
          //$data->orderDropdown['options']['none'] = TEXT_FINDOLOGIC_ORDER_NONE;
          $data->orderDropdown['options']['rank'] = TEXT_FINDOLOGIC_ORDER_RANK;
          $data->orderDropdown['options']['price ASC'] = TEXT_FINDOLOGIC_ORDER_PRICE_ASC;
          $data->orderDropdown['options']['price DESC'] = TEXT_FINDOLOGIC_ORDER_PRICE_DESC;
          $data->orderDropdown['options']['label ASC'] = TEXT_FINDOLOGIC_ORDER_LABEL_ASC;
          $data->orderDropdown['options']['label DESC'] = TEXT_FINDOLOGIC_ORDER_LABEL_DESC;
          $data->orderDropdown['options']['salesfrequency ASC'] = TEXT_FINDOLOGIC_ORDER_SALESFREQUENZY_ASC;
          $data->orderDropdown['options']['salesfrequency DESC'] = TEXT_FINDOLOGIC_ORDER_SALESFREQUENZY_DESC;
          $data->orderDropdown['options']['salesfrequency dynamic ASC'] = TEXT_FINDOLOGIC_ORDER_SALESFREQUENZY_DYNAMIC_ASC;
          $data->orderDropdown['options']['salesfrequency dynamic DESC'] = TEXT_FINDOLOGIC_ORDER_SALESFREQUENZY_DYNAMIC_DESC;
          $data->orderDropdown['options']['dateadded ASC'] = TEXT_FINDOLOGIC_ORDER_DATEADDED_ASC;
          $data->orderDropdown['options']['dateadded DESC'] = TEXT_FINDOLOGIC_ORDER_DATEADDED_DESC;
         */

        $data->orderDropdown['selected'] = $order;
    }

    public function buildPaging($xml, $keywords, $params, $view, &$data) {
        global $xtLink;

        $data->paging['currentPage'] = $view;
        $data->paging['pages'] = ceil((int) $xml->results->count / (int) $xml->query->limit['count']);
        $data->paging['first'] = $xtLink->_link(array('page' => 'vt_findologic', 'params' => "keywords=" . urlencode($keywords) . $params)) . "&view=1";
        $data->paging['previous'] = $xtLink->_link(array('page' => 'vt_findologic', 'params' => "keywords=" . urlencode($keywords) . $params)) . "&view=" . ($view - 1);
        $data->paging['next'] = $xtLink->_link(array('page' => 'vt_findologic', 'params' => "keywords=" . urlencode($keywords) . $params)) . "&view=" . ($view + 1);
        $data->paging['last'] = $xtLink->_link(array('page' => 'vt_findologic', 'params' => "keywords=" . urlencode($keywords) . $params)) . "&view=" . $data->paging['pages'];
    }

    public function checkForLandingpage($xml) {
        if ($xml->landingPage) {
            header('Location: ' . (string) $xml->landingPage['link']);
            exit(0);
        }
    }

    public function checkForPromotions($xml, &$data) {
        if ($xml->promotion) {
            $data->promotion['image'] = (string) $xml->promotion['image'];
            $data->promotion['link'] = (string) $xml->promotion['link'];
        }
    }
}